package com.gabe.message.ejb;

import javax.annotation.PreDestroy;
import javax.ejb.Stateless;
import javax.jms.Destination;
import javax.jms.JMSException;
import javax.jms.Message;

import org.apache.commons.messenger.DefaultMessenger;
import org.apache.commons.messenger.JNDISessionFactory;

/**
 * Session Bean implementation class TestSessionBean
 */
@Stateless
public class TestSessionBean implements TestSession {
   
   private DefaultMessenger _msger;

    /**
     * Default constructor. 
     */
    public TestSessionBean() {
        JNDISessionFactory sessionF = new JNDISessionFactory();
        sessionF.setLookupName("java:/queue/Q.Test");
        sessionF.setTransacted(true);
        
        _msger = new DefaultMessenger();
        _msger.setSessionFactory(sessionF);
        _msger.setJndiDestinations(true);
        _msger.setName("Q.Test");
    }
    
    public void sendMsg(String text) {
       try {
         Destination dest = _msger.getDestination("java:/queue/Q.Test");
         Message msg = _msger.createTextMessage(text);
         _msger.send(dest, msg);
         
      } catch (JMSException e) {
         // TODO Auto-generated catch block
         e.printStackTrace();
      }
    }
    
    @PreDestroy
    public void terminate() {
       try {
         _msger.close();
      } catch (JMSException e) {
         // TODO Auto-generated catch block
         e.printStackTrace();
      }
    }

}
